

int ovrwrite_handle;
int ovrwrite_status;
int ovrwrite_all;


int    ovr_tag=('o'<<24)|('v'<<16)|('r'<<8);


// read choices

void ovrwrite_readchoices(void)
{
 if(tagexists(0,ovr_tag,0))
 {
  ovrwrite_all=tagread(0,ovr_tag,0);
  ovrwrite_status=tagread(0,ovr_tag,1);
 }
 else
 {
  ovrwrite_all=0;
 }
}


// write choices

void ovrwrite_quit(int user)
{
 tagwrite(0,ovr_tag,ovrwrite_all,0);
 tagwrite(0,ovr_tag,ovrwrite_status,1);
}


// if document already exists, give warning

int ovrwrite_fix(int user, int file, string &s)
{
 string t, memtime, disctime;;

 if (objectexists(s))
 {
  if(!(fileinfo(file, t) & 1) || ovrwrite_all)
  {
   t = "{OVRWRITE_04}";
   translate(t);
   if(confirm(t) != 1)
    s = "";
  }
  else
  {
   getfiletimestring("%CE%YR%MN%DY%24%MI%SE", memtime, file);
   gettimestamp("%CE%YR%MN%DY%24%MI%SE", disctime, s);
   if(disctime > memtime)
   {
    t = "{OVRWRITE_05}";
    translate(t);
    if(confirm(t) != 1)
     s = "";
   }
  }
 }
}


// set up EVENT_FPRESAVE events

void ovrwrite_setevent(int i)
{
 if (i)  
  addeventhandler(0x7, 0, "ovrwrite_fix");
 else
  remeventhandler(0x7, 0, "ovrwrite_fix");

 ovrwrite_status = i;
}




// deal with 'Overwrite?' menu entries

int ovrwrite_menu_entry(int entry, int subcode)
{

 switch(entry)
 {
  case 0:
		 ovrwrite_setevent(!ovrwrite_status);
		 break;

  case 1:
  case 2:
         ovrwrite_all = !ovrwrite_all;
		 break;
 }

 return(0);
}


// tick or un-tick 'Overwrite' menu entries

int ovrwrite_menu_flags(int entry, string &text)
{
 switch(entry)
 {

 case 0:
		return(ovrwrite_status|DOTTED);
		break;

 case 1:
        return(!ovrwrite_all);
        break;

 case 2:
        return(ovrwrite_all);
        break;
 }
}


int ovrwrite_menu(int open)
{
 return(ovrwrite_handle);
}


// create 'Overwrite' menu and add it to 'Applets' menu
// enable 'Never saved' overwrite warning

void main(void)
{
 script_menu_initialise();

 ovrwrite_handle = create_menu("{OVRWRITE_01}");
 addentry_menu(ovrwrite_handle, "ovrwrite_menu_entry","ovrwrite_menu_flags","","","{OVRWRITE_06}");
 addentry_menu(ovrwrite_handle, "ovrwrite_menu_entry","ovrwrite_menu_flags","","","{OVRWRITE_02}");
 addentry_menu(ovrwrite_handle, "ovrwrite_menu_entry","ovrwrite_menu_flags","","","{OVRWRITE_03}");

 script_menu_insert("","","ovrwrite_menu","","{OVRWRITE_00}");
 addeventhandler(0x004, 0, "ovrwrite_quit");
 ovrwrite_readchoices();
 ovrwrite_setevent(ovrwrite_status);
}
